#!/usr/bin/perl

use strict ;
use Text::Wrap ;
use LWP::Simple ;

# Max width for lines of text
$Text::Wrap::columns = 50 ;

# Servers definitions including bitmasks
my %servers = ("tdm" => {"name" => "TDM", "bitmask" => 1, "online" => []},
				"bomb" => {"name" => "Bomb", "bitmask" => 2, "online" => []},
				"jump" => {"name" => "Jump", "bitmask" => 4, "online" => []},
				"ts" => {"name" => "TS", "bitmask" => 8, "online" => []},
				"mumble" => {"name" => "Mumble", "bitmask" => 16, "online" => []},
				"irc" => {"name" => "IRC", "bitmask" => 32, "online" => []}) ;

my $link = "http://www.dswp.de/old/dswp_tools/svarox/whoswhere_flat.php" ;

# Gets the page
my @page = split("\n", get($link)) ;
unless (defined @page) {
	print "Data unavailable" ;
	exit ;
}

# Determines on which server people are online
foreach (@page) {
	my @user = split /;/ ;
	foreach my $key (keys %servers) {
		my %serv = %{$servers{$key}} ;
		if (int($user[3]) & $serv{"bitmask"}) {
			push(@{$servers{$key}{"online"}}, $user[1]) ;
		}
	}
}

# Displays the list of servers and users
foreach my $key (keys %servers) {
	my %serv = %{$servers{$key}} ;
	if (@{$servers{$key}{"online"}}) {
		print "--> " . $servers{$key}{"name"} . ":\n";
		print wrap("", "", join(", ", @{$servers{$key}{"online"}}) . "\n") ;
	}
}

